# Kivitendo 4-Design-Pendenzen

## /templates/webpages/

 - **customer_vendor.picker:** für das Auswahlfeld zum Kunden oder Lieferanten wurde in der Funktion "P.customer_vendor.picker" fälschlicherweise im INPUT-Tag das Attribut TYPE für die Zuordnung zu customer/vendor verwendet. <br>Das ist falsch und unerlaubt, wurde aber von Bernd Blessmann an der Froscom 2018 korrigiert. <br>Diese Korrektur wird in der Version 3.5.3 spürbar sein. Aus diesem Grunde müssen sämtliche diesbezügliche Funktionsaufrufe überprüft und angepasst werden. Das Attribut TYPE muss in jedem dieser Tags den reservierten Wert "text" enthalten.
 - **Attribut TYPE im INPUT-Tag:** sämtliche INPUT-Elemente müssen das Attribut TYPE aufweisen. Nur so können die Stylesheets die Formular-Elemente dynamisch formatieren.
 - **Wrapper (.wrapper) in allen Layouts einbauen:** Der Wrapper weist eine Polsterung zum Rand des #Content auf, was deutlich schöner aussieht. Dort, wo die Formularelemente mit den Rändern kollidieren, fehlt dieser Wrapper. Der Wrapper kann mehrmals pro Seite hintereinander eingesetzt werden.<br>Für Tabellen, die sich über die ganze Breite erstrecken (width:100%) ist dieser aber nicht erforderlich.
 - **Auswahl Zeiträume:** Beispiel /rp.pl?report=erfolgsrechnung&action=report<br>Diese Auswahl-Elemente für Berichte sind mindestens sieben Mal oder mehr in den Kivitendo-Templates vorhanden, und sind also Redundanzen. Diese Elemente sollten im /templates/webpages/common/ oder anderswo einmalig gespeichert sein, verfügbar via INCLUDE. Mit dem Bonner Kivitendo-Team absprechen und genau anschauen, denn es könnte in einem Fall leichte Abweichungen geben. Zudem sollten LABEL für die Auswahl der Options-/Checkboxen via Klick auf den Text eingesetzt werden.
 - **/templates/webpages/amcvar/search_include.html:** DIVs um Label & Checkbox (Table-Elemente werden automatisch entfernt)
 - **/templates/webpages/mass_invoice_create_print_from_do/_filter.html:** Ueberpruefen, ob Formular richtig kommen.
 - **templates/webpages/generic/print_options.html:** body-Tag anstelle von tbody-Tag
 - **templates/webpages/do/form_footer.html:** set RO=' readonly' -> wohin verschwunden?
 - **templates/webpages/acc_trans/_mini_ledger.html:** TR in TFOOT nicht vorh.
 - **templates/webpages/part/_edit_translations.html:** Hunk 'SET language_id' mit fehlendem Komma
 - **templates/webpages/part/_multi_items_result.html:** ausgabe ueberpruefen
 - **templates/webpages/order/tabs/_row.html:** rowspan="100%" (falsch)
 - **templates/webpages/order/tabs/_second_row.html:** [% var.config.description %] ist nicht mehr vorhanden
 - **templates/webpages/shops/form.html:** Abschliessendes </tr> fehlt bei [% 'Shop type' | $T8 %]



## Übersetzungen
 - Alle neuen Textelemente müssen übersetzt werden.

## Messages

### Zwei verschiedene Arten von Styles
Es gibt die alten, einfachen Messages, die in einem Paragrafen oder einem DIV untergebracht sind. Und dann gibt es noch die neueren Flash-Messages, die jeweils verborgen (display:none;) in praktisch jedem #content→form untergebracht sind. Hier wäre eine Vereinheitlichung anzustreben. Ist allerdings im LESS/CSS berücksichtigt.

### Doppelte bzw. zweifache Message in Dialog-Buchung
Beim Buchen erscheinen zwei Nachrichten; eine im alten Standard-Formular und eine im neuen .Flash_Message-Format.
Eine zusammengefasst würde ja genügen, auch im vorgesehenen neuen Stil: https://rochen.revamp-it.ch:25443/design4/gl.pl?action=add



## Features-Vorschläge

### Dialog-Buchen
Nach der Buchungsmaske Liste mit allen Buchungen des Benutzers am gleichen Tag.
Somit hätte der Buchende die Möglichkeit, allfällige Fehler frühzeitig zu erkennen und zu korrigieren.
https://rochen.revamp-it.ch:25443/design4/gl.pl?action=add


## Control-Panels
Alle Beschriftungen in Span.Label-Container einpassen. Ausrichtung oben mit entsprechender Anpassung für alle anderen Elementen. Dies ist vor allem noetig, weil Select-Elemente später u.U. vergrössert werden könnten (z.B. Anzeige aller Ansprechspersonen)



